//Funzione per la decomposizioni in stati stabili/instabili
function [ga,gs]=dtsi_mod(g)

tipo=g(7);
if (tipo == 'c')
  [a,b,c,d]=g(2:5),
  [n1,n2,t]=size(g),
  [a,u0]=balanc(a);b=u0\b;c=c*u0;
  [u,n]=schur(a,'c'),
  a=u'*a*u,
  if n==t then ga=0,
    gs=g,return,
  end,
  if n==0 then gs=0,
    ga=g,return,
  end,
  //      [ab,w,bs]=bdiag(a);
  a1=a(1:n,1:n),a4=a(n+1:t,n+1:t),x=a(1:n,n+1:t),
  z=sylv(a1,-a4,-x,'c'),
  w=[eye(n,n),z;0*ones(t-n,n),eye(t-n,t-n)],
  wi=[eye(n,n),-z;0*ones(t-n,n),eye(t-n,t-n)],
  tr=u*w,tri=wi*u';
  bb=tri*b,b1=bb(1:n,:),b2=bb(n+1:t,:),
  cc=c*tr,c1=cc(:,1:n),c2=cc(:,n+1:t),
  ga=syslin('c',a4,b2,c2),
  gs=syslin('c',a1,b1,c1);
end
  
if (tipo == 'd')

  [a,b,c,d]=g(2:5),
  [n1,n2,t]=size(g),
  [a,u0]=balanc(a);b=u0\b;c=c*u0;
  [u,n]=schur(a,'d'),
  a=u'*a*u,
  if n==t then ga=0,
    gs=g,return,
  end,
  if n==0 then gs=0,
    ga=g,return,
  end,
  //      [ab,w,bs]=bdiag(a);
  a1=a(1:n,1:n),a4=a(n+1:t,n+1:t),x=a(1:n,n+1:t),
  z=sylv(a1,-a4,-x,'d'),
  w=[eye(n,n),z;0*ones(t-n,n),eye(t-n,t-n)],
  wi=[eye(n,n),-z;0*ones(t-n,n),eye(t-n,t-n)],
  tr=u*w,tri=wi*u';
  bb=tri*b,b1=bb(1:n,:),b2=bb(n+1:t,:),
  cc=c*tr,c1=cc(:,1:n),c2=cc(:,n+1:t),
  ga=syslin('d',a4,b2,c2),
  gs=syslin('d',a1,b1,c1);

end


endfunction
